<template>
  <div class="h-full flex flex-col space-y-8">
    <main class="flex-auto">
      <Component
        :is="getCurrentComponent"
        @nextStage="nextStage"
        @goTo="goToStage"
        @nextTreatment="nextTreatment"
        :treatment-name="treatmentStages[currentTreatmentStage]"
      />
    </main>
    <footer class="flex justify-center items-center">
      <img
        src="@/assets/img/icons/lock.png"
        width="14"
        alt="lock icon"
        class="mr-3"
      >
      <span class="text-xs text-grey-dark">
        256-bit TLS Security
      </span>
    </footer>
  </div>
</template>

<script>

import YourHealth1 from "@/components/quizes/YourHealth/YourHealth1";
import YourHealth2 from "@/components/quizes/YourHealth/YourHealth2";
import YourHealth3 from "@/components/quizes/YourHealth/YourHealth3";
import YourHealth4 from "@/components/quizes/YourHealth/YourHealth4";
import YourHealth5 from "@/components/quizes/YourHealth/YourHealth5";
import YourHealth6 from "@/components/quizes/YourHealth/YourHealth6";
import YourHealth7 from "@/components/quizes/YourHealth/YourHealth7";
import YourHealth8 from "@/components/quizes/YourHealth/YourHealth8";
import YourHealth9 from "@/components/quizes/YourHealth/YourHealth9";
import YourHealth10 from "@/components/quizes/YourHealth/YourHealth10";
import YourHealth11 from "@/components/quizes/YourHealth/YourHealth11";
import YourHealth12 from "@/components/quizes/YourHealth/YourHealth12";
import YourHealth13 from "@/components/quizes/YourHealth/YourHealth13";
import YourHealth14 from "@/components/quizes/YourHealth/YourHealth14";
import YourHealth15 from "@/components/quizes/YourHealth/YourHealth15";
import YourHealth16 from "@/components/quizes/YourHealth/YourHealth16";
import YourHealth17 from "@/components/quizes/YourHealth/YourHealth17";
import YourHealth18 from "@/components/quizes/YourHealth/YourHealth18";
import YourHealth19 from "@/components/quizes/YourHealth/YourHealth19";
import YourHealth20 from "@/components/quizes/YourHealth/YourHealth20";
import YourHealth21 from "@/components/quizes/YourHealth/YourHealth21";
import YourHealth22 from "@/components/quizes/YourHealth/YourHealth22";
import YourHealth23 from "@/components/quizes/YourHealth/YourHealth23";
import YourHealth24 from "@/components/quizes/YourHealth/YourHealth24";
import YourHealth25 from "@/components/quizes/YourHealth/YourHealth25";
import YourHealth26 from "@/components/quizes/YourHealth/YourHealth26";
import YourHealth27 from "@/components/quizes/YourHealth/YourHealth27";
import YourHealth28 from "@/components/quizes/YourHealth/YourHealth28";
import YourHealth29 from "@/components/quizes/YourHealth/YourHealth29";
import YourHealth30 from "@/components/quizes/YourHealth/YourHealth30";
import YourHealth32 from "@/components/quizes/YourHealth/YourHealth32";
import YourHealth33 from "@/components/quizes/YourHealth/YourHealth33";
import YourHealth34 from "@/components/quizes/YourHealth/YourHealth34";
import YourHealth35 from "@/components/quizes/YourHealth/YourHealth35";
import {answersMixin} from "@/utils/mixins";
import {constants} from "@/constants";

export default {
  name: "YourHealth",
  mixins: [answersMixin],
  data() {
    return {
      currentTreatmentStage: 0,
      stages: {
        1: YourHealth1, 2: YourHealth2, 3: YourHealth3,
        4: YourHealth4, 5: YourHealth5, 6: YourHealth6,
        7: YourHealth7, 8: YourHealth8, 9: YourHealth9,
        10: YourHealth10, 11: YourHealth11, 12: YourHealth12,
        13: YourHealth13, 14: YourHealth14, 15: YourHealth15,
        16: YourHealth16, 17: YourHealth17, 18: YourHealth18,
        19: YourHealth19, 20: YourHealth20, 21: YourHealth21,
        22: YourHealth22, 23: YourHealth23, 24: YourHealth24,
        25: YourHealth25, 26: YourHealth26, 27: YourHealth27,
        28: YourHealth28, 29: YourHealth29, 30: YourHealth30,
        31: YourHealth32, 32: YourHealth33,
        33: YourHealth34, 34: YourHealth35
      },
      stageNumber: 1,
    }
  },
  methods: {
    nextStage() {
      if (this.stageNumber >= this.maxStages) {
        this.$emit('nextStage')
      } else {
        if (this.stageNumber === 8 && !this.treatmentStages.length) {
          this.goToStage(11)
        } else this.stageNumber++
      }
    },
    goToStage(number) {
      this.stageNumber = number
    },
    nextTreatment() {
      if (this.currentTreatmentStage === (this.treatmentStages.length - 1)) {
        this.nextStage()
      } else {
        this.stageNumber = 9
        this.currentTreatmentStage++
      }
    }
  },
  computed: {
    getCurrentComponent() {
      return this.stages[this.stageNumber]
    },
    maxStages() {
      return Object.keys(this.stages).length
    },
    treatmentStages() {
      return (this.answer(this.answersKeys.YOUR_HEALTH)?.['stage_8'] || []).filter(answer => answer !== constants.NONE_CHOICE)
    }
  }
}
</script>

<style scoped>

</style>
